Attribute VB_Name = "CheckConnection"
'   
Private Declare Function RasEnumConnections Lib "RasApi32.dll" Alias "RasEnumConnectionsA" _
                                            (lpRasCon As Any, lpcb As Long, _
                                            lpcConnections As Long) As Long
                                            
Private Declare Function RasGetConnectStatus Lib "RasApi32.dll" Alias "RasGetConnectStatusA" _
                                                 (ByVal hRasCon As Long, _
                                                 lpStatus As Any) As Long
                                                 
    Private Const RAS95_MaxEntryName = 256
    Private Const RAS95_MaxDeviceType = 16
    Private Const RAS95_MaxDeviceName = 32

' RASCONN95
 Private Type RASCONN95
    dwSize As Long
    hRasCon As Long
    szEntryName(RAS95_MaxEntryName) As Byte
    szDeviceType(RAS95_MaxDeviceType) As Byte
    szDeviceName(RAS95_MaxDeviceName) As Byte
 End Type

' RASCONNSTATUS95
 Private Type RASCONNSTATUS95
    dwSize As Long
    RasConnState As Long
    dwError As Long
    szDeviceType(RAS95_MaxDeviceType) As Byte
    szDeviceName(RAS95_MaxDeviceName) As Byte
 End Type
Public Function IsConnected() As Boolean
    Dim TRasCon(255) As RASCONN95
    Dim lg As Long
    Dim lpcon As Long
    Dim retval As Long
    Dim Tstatus As RASCONNSTATUS95

    TRasCon(0).dwSize = 412
    lg = 256 * TRasCon(0).dwSize
    retval = RasEnumConnections(TRasCon(0), lg, lpcon)
    Tstatus.dwSize = 160
    retval = RasGetConnectStatus(TRasCon(0).hRasCon, Tstatus)
        If Tstatus.RasConnState = &H2000 Then
            IsConnected = True
        Else
            IsConnected = False
        End If
End Function


