VERSION 5.00
Begin VB.Form frmTcpStats 
   BorderStyle     =   1  'Fixed Single
   Caption         =   "   "
   ClientHeight    =   1350
   ClientLeft      =   45
   ClientTop       =   330
   ClientWidth     =   5175
   Icon            =   "frmTcpStats.frx":0000
   LinkTopic       =   "Form1"
   MaxButton       =   0   'False
   MinButton       =   0   'False
   ScaleHeight     =   1350
   ScaleWidth      =   5175
   StartUpPosition =   2  'CenterScreen
   Begin VB.Timer Timer3 
      Interval        =   1000
      Left            =   4560
      Top             =   0
   End
   Begin VB.Timer Timer2 
      Enabled         =   0   'False
      Interval        =   500
      Left            =   3600
      Top             =   0
   End
   Begin VB.CommandButton cmdSave 
      Caption         =   ""
      Height          =   375
      Left            =   120
      TabIndex        =   4
      Top             =   840
      Width           =   3495
   End
   Begin VB.TextBox Text1 
      Height          =   375
      Left            =   120
      TabIndex        =   2
      Top             =   360
      Width           =   3495
   End
   Begin VB.Timer Timer1 
      Interval        =   1000
      Left            =   3240
      Top             =   0
   End
   Begin VB.CommandButton cmdExit 
      Caption         =   "E&xit"
      Height          =   375
      Left            =   3720
      TabIndex        =   1
      Top             =   600
      Width           =   1335
   End
   Begin VB.CommandButton cmdHide 
      Caption         =   "&Hide"
      Height          =   375
      Left            =   3720
      TabIndex        =   0
      Top             =   120
      Width           =   1335
   End
   Begin VB.Label Label1 
      Caption         =   "  ,   0"
      Height          =   255
      Left            =   120
      TabIndex        =   3
      Top             =   120
      Width           =   3135
   End
   Begin VB.Menu mPopupSys 
      Caption         =   "&SysTray"
      Visible         =   0   'False
      Begin VB.Menu mPopExit 
         Caption         =   "&"
      End
   End
End
Attribute VB_Name = "frmTcpStats"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
'user defined type required by Shell_NotifyIcon API call
Private Type NOTIFYICONDATA
    cbSize As Long
    hwnd As Long
    uId As Long
    uFlags As Long
    uCallBackMessage As Long
    hIcon As Long
    szTip As String * 64
End Type

'constants required by Shell_NotifyIcon API call:
Private Const NIM_ADD = &H0
Private Const NIM_MODIFY = &H1
Private Const NIM_DELETE = &H2
Private Const NIF_MESSAGE = &H1
Private Const NIF_ICON = &H2
Private Const NIF_TIP = &H4
Private Const WM_MOUSEMOVE = &H200
Private Const WM_LBUTTONDOWN = &H201     'Button down
Private Const WM_LBUTTONUP = &H202       'Button up
Private Const WM_LBUTTONDBLCLK = &H203   'Double-click
Private Const WM_RBUTTONDOWN = &H204     'Button down
Private Const WM_RBUTTONUP = &H205       'Button up
Private Const WM_RBUTTONDBLCLK = &H206   'Double-click

Private Declare Function SetForegroundWindow Lib "user32" (ByVal hwnd As Long) As Long
Private Declare Function Shell_NotifyIcon Lib "shell32" Alias "Shell_NotifyIconA" (ByVal dwMessage As Long, pnid As NOTIFYICONDATA) As Boolean

Private nid As NOTIFYICONDATA

'user defined type required by GetTcpStatistics API call
Private Type MIB_TCPSTATS
    dwRtoAlgorithm  As Long '// timeout algorithm
    dwRtoMin        As Long '// minimum timeout
    dwRtoMax        As Long '// maximum timeout
    dwMaxConn       As Long '// maximum connections
    dwActiveOpens   As Long '// active opens
    dwPassiveOpens  As Long '// passive opens
    dwAttemptFails  As Long '// failed attempts
    dwEstabResets   As Long '// establised connections reset
    dwCurrEstab     As Long '// established connections
    dwInSegs        As Long '// segments received
    dwOutSegs       As Long '// segment sent
    dwRetransSegs   As Long '// segments retransmitted
    dwInErrs        As Long '// incoming errors
    dwOutRsts       As Long '// outgoing resets
    dwNumConns      As Long '// cumulative connections
End Type

Private Declare Function GetTcpStatistics Lib "iphlpapi.dll" (pStats As MIB_TCPSTATS) As Long
Public Difference As Long

Private Sub cmdExit_Click()
    Unload Me
End Sub

Private Sub cmdHide_Click()
    Me.Hide
End Sub
Private Sub Form_Load()
    Dim frFile As Integer
    Dim temp As String
    '
    Me.Hide
    Me.Refresh
    '
    frFile = FreeFile
    Open App.Path & "\acheck.ini" For Input As frFile
    Line Input #1, temp
    Close
    Text1.Text = temp
    Difference = temp
    AddIcon
End Sub
Private Sub cmdSave_Click()
    Dim frFile As Integer
    Text1.Text = Trim(Text1.Text)
    If Text1.Text = "" Then Text1.Text = 0
    frFile = FreeFile
    Open App.Path & "\acheck.ini" For Output As frFile
    Print #frFile, Text1
    Close
    Difference = Text1.Text
    Timer1.Interval = 65000
End Sub

Private Sub Form_MouseMove(Button As Integer, Shift As Integer, X As Single, Y As Single)
    '
    'this procedure receives the callbacks from the System Tray icon.
    '
    Dim Result As Long
    Dim msg As Long
    '
    'the value of X will vary depending upon the scalemode setting
    '
    If Me.ScaleMode = vbPixels Then
        msg = X
    Else
        msg = X / Screen.TwipsPerPixelX
    End If
    '
    Select Case msg
        Case WM_RBUTTONUP        '517 display popup menu
            Result = SetForegroundWindow(Me.hwnd)
            Me.PopupMenu Me.mPopupSys
        Case WM_LBUTTONDBLCLK
            Me.Visible = True
            Me.WindowState = vbNormal
    End Select
End Sub
Private Sub Form_Unload(Cancel As Integer)
    Shell_NotifyIcon NIM_DELETE, nid
End Sub
Private Sub Timer1_Timer()
    UpdateStats
End Sub
Private Sub UpdateStats()
    '
    Dim tStats          As MIB_TCPSTATS
    Static tStaticStats As MIB_TCPSTATS
    '
    Static LastRCVD As Long
    '
    Dim lRetValue       As Long
    '
    Dim blnIsSent       As Boolean
    Dim blnIsRecv       As Boolean
    '
    If IsConnected = False Then
        With tStats
         .dwInSegs = 0
         .dwOutSegs = 0
        End With
        LastRCVD = 0
        Exit Sub
    End If
    
    lRetValue = GetTcpStatistics(tStats)
    
    If tStats.dwOutSegs - LastRCVD <= Difference Then
        Timer2.Enabled = True
        Me.Icon = LoadResPicture(103, 1)
        AddIcon
    Else
        Timer1.Interval = 65000
        Me.Icon = LoadResPicture(101, 1)
        AddIcon
    End If
    
    blnIsRecv = (tStats.dwInSegs > tStaticStats.dwInSegs)
    blnIsSent = (tStats.dwOutSegs > tStaticStats.dwOutSegs)
    tStaticStats = tStats
    LastRCVD = tStats.dwOutSegs
End Sub
Private Sub mPopExit_Click()
    Unload Me
End Sub
Private Sub mPopRestore_Click()
    Me.WindowState = vbNormal
    Result = SetForegroundWindow(Me.hwnd)
    Me.Show
End Sub
Private Sub Timer2_Timer()
    Static Count As Integer
    Count = Count + 1
    PlaySound
    If Count = 10 Then
        Count = 0
        Timer2.Enabled = False
    End If
End Sub
Sub AddIcon()
    With nid
        .cbSize = Len(nid)
        .hwnd = Me.hwnd
        .uId = vbNull
        .uFlags = NIF_ICON Or NIF_TIP Or NIF_MESSAGE
        .uCallBackMessage = WM_MOUSEMOVE
        .hIcon = Me.Icon
        .szTip = " " & vbNullChar
    End With
    Shell_NotifyIcon NIM_ADD, nid
    Shell_NotifyIcon NIM_MODIFY, nid
End Sub
Private Sub Timer3_Timer()
    If IsConnected = False Then
        Timer1.Interval = 1000
        Me.Icon = LoadResPicture(102, 1)
        AddIcon
    End If
End Sub
